Main Page Namespace List Class Hierarchy Alphabetical List Compound List Namespace Members Compound Members Related Pages

# Composition::SceneC Class Reference

Composition scene class. More...

`#include <SceneC.h>`

Inheritance diagram for Composition::SceneC:

List of all members.

## Public Methods

- virtual Edit::DataBlockI* create ()
- virtual Edit::DataBlockI* create ( Edit::EditableI* pOriginal )
- virtual void copy ( Edit::DataBlockI* pBlock )
- virtual void restore ( Edit::EditableI* pEditable )
- void set_name ( const char* szName )
- const char* get_name () const
- PajaTypes::uint32 get_layer_count ()
- LayerC* get_layer ( PajaTypes::uint32 ui32Index )
- LayerC* add_layer ()
- void del_layer ( PajaTypes::uint32 ui32Index )
- void move_layer_before ( PajaTypes::uint32 ui32Index, PajaTypes::uint32 ui32IndexBefore )
- PajaTypes::int32 get_beats_per_min ()
- void set_beats_per_min ( PajaTypes::int32 i32BeatsPerMin )
- PajaTypes::int32 get_edit_accuracy ()
- void set_edit_accuracy ( PajaTypes::int32 i32Accuracy )
- PajaTypes::int32 get_beats_per_measure ()
- void set_beats_per_measure ( PajaTypes::int32 i32Beats )
- PajaTypes::int32 get_qnotes_per_beat ()
- void set_qnotes_per_beat ( PajaTypes::int32 i32QNotes )
- PajaTypes::int32 get_duration ()
- void set_duration ( PajaTypes::int32 i32Duration )
- PajaTypes::int32 get_layout_width ()
- void set_layout_width ( PajaTypes::int32 i32Width )
- PajaTypes::int32 get_layout_height ()
- void set_layout_height ( PajaTypes::int32 i32Height )
- PajaTypes::uint32 save ( FileIO::SaveC* pSave )
- PajaTypes::uint32 load ( FileIO::LoadC* pLoad )
- PajaTypes::uint32 load ( FileIO::LoadC* pLoad, bool bMerge )

## Static Public Methods

- SceneC* create_new ()

## Protected Methods

- SceneC ()
- SceneC ( Edit::EditableI* pOriginal )
- virtual ~SceneC ()

## Detailed Description

Composition scene class.

The base of the demo in Demopaja is scene. The layers are store inside the scene. Scene also contains information about the size of the canvas where the demo is shown and the speed of the demo.

The changes made to the scene is saved to a undo object if present.

This class is implemented by the system.

## Constructor & Destructor Documentation

SceneC ( | )`[protected]`

| Default constructor.

SceneC ( | Edit::EditableI * pOriginal )`[protected]`

| Constructor with reference to the original.

~SceneC ( | )`[protected, virtual]`

| Default destructor.

## Member Function Documentation

LayerC * add_layer ( | )

| Adds new layer to the scene.

void copy ( | Edit::DataBlockI * pBlock )`[virtual]`

| Deep copy from a data block, see Edit::DataBlockI::copy(). Reimplemented from Edit::EditableI.

Edit::DataBlockI * create ( | Edit::EditableI * pOriginal )`[virtual]`

| Creates new scene (used internally), see Edit::EditableI::create(). Reimplemented from Edit::EditableI.

Edit::DataBlockI * create ( | )`[virtual]`

| Creates new, empty scene. Reimplemented from Edit::EditableI.

SceneC * create_new ( | )`[static]`

| Creates new, empty scene.

void del_layer ( | PajaTypes::uint32 ui32Index )

| Deletes a layer at specified index.

PajaTypes::int32 get_beats_per_measure ( | )

| Returns number of beats per measure of the demo.

PajaTypes::int32 get_beats_per_min ( | )

| Returns number of beats per minute (BPM) of the demo.

PajaTypes::int32 get_duration ( | )

| Returns the duration of the demo. The return value is number of quater-notes multiplied by 256.

PajaTypes::int32 get_edit_accuracy ( | )

| Returns the edit accuracy of the demo.

LayerC * get_layer ( | PajaTypes::uint32 ui32Index )

| Returns a layer at specified index.

PajaTypes::uint32 get_layer_count ( | )

| Returns number of layers in the scene.

PajaTypes::int32 get_layout_height ( | )

| Returns the height of the layout in pixels.

PajaTypes::int32 get_layout_width ( | )

| Returns the width of the layout in pixels.

const char * get_name ( | ) const

| Returns the name of the scene.

PajaTypes::int32 get_qnotes_per_beat ( | )

| Returns number of quater-notes per beat.

PajaTypes::uint32 load ( | FileIO::LoadC * pLoad,
| bool bMerge )

| Serialize the key from a Demopaja input stream with merge to old scnene.

PajaTypes::uint32 load ( | FileIO::LoadC * pLoad )`[virtual]`

| Serialize the key from a Demopaja input stream. Reimplemented from Edit::EditableI.

void move_layer_before ( | PajaTypes::uint32 ui32Index,
| PajaTypes::uint32 ui32IndexBefore )

  | Moves the order of a layer. Parameters:
  ui32Index | the index of the layer to move.
  ui32IndexBefore | the index of the layer before the layer is moved. Moves the layer before another layer.

void restore ( | Edit::EditableI * pEditable )`[virtual]`

| Shallow copy from a editable, see Edit::EditableI::restore(). Reimplemented from Edit::EditableI.

PajaTypes::uint32 save ( | FileIO::SaveC * pSave )`[virtual]`

| Serialize the key to a Demopaja output stream. Reimplemented from Edit::EditableI.

void set_beats_per_measure ( | PajaTypes::int32 i32Beats )

| Sets number of beats per measure of the demo.

void set_beats_per_min ( | PajaTypes::int32 i32BeatsPerMin )

| Sets number of beats per minute (BPM) of the demo.

void set_duration ( | PajaTypes::int32 i32Duration )

| Sets the duration of the demo.

void set_edit_accuracy ( | PajaTypes::int32 i32Accuracy )

| Sets the edit accuracy of the demo.

void set_layout_height ( | PajaTypes::int32 i32Height )

| Sets the height of the layout in pixels.

void set_layout_width ( | PajaTypes::int32 i32Width )

| Sets the width of the layout in pixels.

void set_name ( | const char * szName )

| Sets the name of the scene.

void set_qnotes_per_beat ( | PajaTypes::int32 i32QNotes )

| Sets number of quater-notes per beat.

The documentation for this class was generated from the following file:

- SceneC.h